<?php
/**
* <b>CrackerTracker File: ct_security.php</b><br><br>
*
* This file is responsible for the worm protection Unit of the CrackerTracker
* Security System. The File includes a definition Array wich is used to
* heuristically scan URL requests for attacks.
*
* We included some virtual Troopers for you. ;-)
*
*
* @author Christian Knerr (cback)
* @package ctracker
* @version 5.0.1
* @since 15.07.2006 - 21:36:24
* @copyright (c) 2006 www.cback.de
*
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

if( !defined('IN_PHPBB') )
{
	die("Hacking attempt!");
}

/*
 * The first thing we do now is checking the integrity of the $phpbb_root_path
 * because CrackerTracker will need it later. With this step we prevent that
 * scripts without the $phpbb_root_path or without a validated $phpbb_root_path
 * can be executed.
 */
if ( !isset($phpbb_root_path) || empty($phpbb_root_path) )
{
	/*
	 * Create a HTML error Message output
	 */
	$htmloutput =<<<EOM
  <html>
				     <head>
    				   <title>CBACK CrackerTracker :: Security Alert</title>
  					 </head>
  					 <body>
    				   <br>
    				   <div align="center">
      				   <table style="border:2px solid #000000" border="0" width="600" cellpadding="10" cellspacing="0">
         			     <tr>
          				   <td align="left" bgcolor="#000000"><font face="Tahoma, Arial, Helvetica" size="4" color="#FFFFFF"><b>SECURITY ALERT &raquo; &raquo; &raquo; &raquo;</b></font></td>
        				 </tr>
        				 <tr>
          				   <td bgcolor="#FFF4BF" align="left">
          						<font face="Tahoma, Arial, Helvetica" size="2" color="#000000">
          						  CBACK CrackerTracker stopped your script because the engine detected
          						  that the script you want to execute has not initialized the var
          						  <b>\$phpbb_root_path</b> correctly.
          						  <br><br>
          						  This could be a potential security risk for this board.
          						  <br><br>
          						  If you are not the admin of this Board please contact him and tell him from
          						  this warning message and what you have done that he has the possibility to
          						  fix that problem.
          						</font>
          				    </td>
        				   </tr>
      				     </table>
    				   </div>
  					 </body>
				   </html>
EOM;

	// Lets stop the script
	die($htmloutput);
}


/*
 * Now we define an array where all definition data is saved in.
 * After that we check URL committals for potential worm acitivities
 */
$ct_rules = array('http_', '_server', 'delete%20', 'delete ', 'drop%20', 'drop ', 'create%20',
				  'create ', 'update%20', 'update ', 'insert%20', 'insert ',
          'select%20', 'select ', 'bulk%20', 'bulk ', 'union%20', 'union ',
				  'or%20', 'or ', 'and%20', 'and ', 'exec', '@@', '%22', '"', 'openquery',
				  'openrowset', 'msdasql', 'sqloledb', 'sysobjects', 'syscolums',
				  'syslogins', 'sysxlogins', 'char%20', 'char ', 'into%20', 'into ',
				  'load%20', 'load ', '*', 'msys', 'alert%20', 'alert ', 'eval%20', 'eval ',
          'onkeyup', 'x5cx', 'fromcharcode', 'javascript:', 'javascript.', 'vbscript:',
				  'vbscript.', 'http-equiv', '->', 'expression%20', 'expression ',
				  'url%20', 'url ', 'innerhtml', 'document.', 'dynsrc', 'jsessionid',
				  'style%20', 'style ', 'phpsessid', '<applet', '<div', '<emded', '<iframe', '<img',
				  '<meta', '<object', '<script', '<textarea', 'onabort', 'onblur',
				  'onchange', 'onclick', 'ondblclick', 'ondragdrop', 'onerror',
				  'onfocus', 'onkeydown', 'onkeypress', 'onload', 'onmouse',
				  'onmove', 'onreset', 'onresize', 'onselect', 'onsubmit',
				  'onunload', 'onreadystatechange', 'xmlhttp', 'uname%20', 'uname ',
				  'id%20', 'id ', 'ls%20', 'ls ', 'cat%20', 'cat ', 'rm%20', 'rm ',
          'kill%20', 'kill ', 'mail%20', 'mail ', 'wget%20', 'wget ', 'wget(',
          'pwd%20', 'pwd ', 'objectclass', 'objectcategory', '<!-%20', '<!- ',
          'total%20', 'total ', 'http%20request', 'http request', 'phpb8b4f2a0',
          'phpinfo', 'php:', 'globals', '%2527', '%27', '\'', 'chr(',
				  'chr=', 'chr%20', 'chr ', '%20chr', ' chr', 'cmd=', 'cmd%20', 'cmd',
          '%20cmd', ' cmd', 'rush=', '%20rush', ' rush', 'rush%20', 'rush ',
          'union%20', 'union ', '%20union', ' union', 'union(', 'union=',
				  '%20echr', ' echr', 'esystem', 'cp%20', 'cp ', 'cp(', '%20cp', ' cp',
          'mdir%20', 'mdir ', '%20mdir', ' mdir', 'mdir(', 'mcd%20', 'mcd ',
          'mrd%20', 'mrd ', 'rm%20', 'rm ', '%20mcd', ' mcd', '%20mrd', ' mrd',
          '%20rm', ' rm', 'mcd(', 'mrd(', 'rm(', 'mcd=', 'mrd=', 'mv%20', 'mv ',
				  'rmdir%20', 'rmdir ', 'mv(', 'rmdir(', 'chmod(', 'chmod%20', 'chmod ',
          'cc%20', 'cc ', '%20chmod', ' chmod', 'chmod(', 'chmod=', 'chown%20', 'chown ',
          'chgrp%20', 'chgrp ', 'chown(', 'chgrp(', 'locate%20', 'locate ', 'grep%20', 'grep ',
          'locate(', 'grep(', 'diff%20', 'diff ', 'kill%20', 'kill ', 'kill(', 'killall',
          'passwd%20', 'passwd ', '%20passwd', ' passwd', 'passwd(', 'telnet%20', 'telnet ',
          'vi(', 'vi%20', 'vi ', 'nigga(', '%20nigga', ' nigga', 'nigga%20', 'nigga ',
          'fopen', 'fwrite', '%20like', ' like', 'like%20', 'like ', '$_',
				  '$get', '.system', 'http_php', '%20getenv', ' getenv', 'getenv%20', 'getenv ',
				  'new_password', '/password', 'etc/', '/groups', '/gshadow',
				  'http_user_agent', 'http_host', 'bin/', 'wget%20', 'wget ', 'uname%5c',
				  'uname\\', 'usr', '/chgrp', '=chown', 'usr/bin', 'g%5c',
				  'g\\', 'bin/python', 'bin/tclsh', 'bin/nasm', 'perl%20', 'perl ', '.pl',
				  'traceroute%20', 'traceroute ', 'tracert%20', 'tracert ', 'ping%20', 'ping ',
				  '/usr/x11r6/bin/xterm', 'lsof%20', 'lsof ', '/mail', '.conf', 'motd%20', 'motd ',
				  'http/1.', '.inc.php', 'config.php', 'cgi-', '.eml', 'file%5c://',
				  'file\:', 'file://', 'window.open', 'img src', 'img%20src', 'img src',
				  '.jsp', 'ftp.', 'xp_enumdsn', 'xp_availablemedia',
				  'xp_filelist', 'nc.exe', '.htpasswd', 'servlet', '/etc/passwd', '/etc/shadow',
				  'wwwacl', '~root', '~ftp', '.js', '.jsp', '.history',
				  'bash_history', '~nobody', 'server-info', 'server-status',
				  '%20reboot', ' reboot', '%20halt', ' halt', '%20powerdown', ' powerdown',
          '/home/ftp', '=reboot', 'www/', 'init%20', 'init ','=halt', '=powerdown',
          'ereg(', 'secure_site', 'chunked', 'org.apache', '/servlet/con',
				  '/robot', 'mod_gzip_status', '.inc', '.system', 'getenv',
				  'http_', '_php', 'php_', 'phpinfo()', '<?php', '?>', '%3C%3Fphp',
				  '%3F>', 'sql=', '_global', 'global_', 'global[', '_server',
				  'server_', 'server[', '/modules', 'modules/', 'phpadmin',
				  'root_path', '_globals', 'globals_', 'globals[', 'iso-8859-1',
				  '?hl=', '%3fhl=', '.exe', '.sh', '%00', rawurldecode('%00'), '_env');

// Initialize detector var
$ct_attack_detection = false;

// Write query String in the var $cracktrack and make it lowercase
$cracktrack = strtolower($HTTP_SERVER_VARS['QUERY_STRING']);

// Prevent tricks wich comment out SQL commands
$cracktrack = str_replace(array('/', '*'), '', $cracktrack);
$cracktrack = str_replace('\\', '(', $cracktrack);

// Now we do a very simple method to mark potential Worm activities
$checkworm = str_replace($ct_rules, '*', $cracktrack);
if ( $cracktrack != $checkworm )
{
	$ct_attack_detection = true;
}

$checkworm = str_replace($ct_rules, '*', rawurldecode($cracktrack));
if ( rawurldecode($cracktrack) != $checkworm )
{
	$ct_attack_detection = true;
}

// We create a copy of the $HTTP_POST_VARS for checking
$checkpost = ( is_array($HTTP_POST_VARS) ) ? $HTTP_POST_VARS : array();

// Now we have a look to $HTTP_POST_VARS
foreach ( $checkpost as $post_var_fieldname => $post_var_field_value )
{
	// Some fields in $HTTP_POST_VARS don't get checked to prevent wrong detection
	$unchecked_fields   = array('username', 'password', 'subject', 'message',
								'poll_title', 'poll_option', 'poll_delete',
								'email', 'confirm_code', 'aim', 'msn', 'yim',
								'interests', 'occupation', 'signature', 'website',
								'location', 'search', 'sitename', 'word',
								'replacement', 'help', 'last_msg', 'quote', 'dl',
								'preview', 'post', 'mode', 'content', 'server_name',
								'script_path', 'sitename', 'site_desc', 'disable_reg_msg',
								'disable_msg', 'cookie', 'avatar', 'file', 'picture',
								'filter', 'xs', 'edit', 'content', 'fileupload', 'filecomment',
								'comment', 'rate', 'pic');
	$is_unchecked_field = str_replace($unchecked_fields, '', $post_var_fieldname);

	if ( $is_unchecked_field == $post_var_fieldname )
	{
		// Prevent tricks wich comment out SQL commands
		$post_var_field_value = str_replace(array('/', '*'), '', $post_var_field_value);

		// Now we do a very simple method to mark potential Worm activities
		$check_post_var = str_replace($ct_rules, '*', $post_var_field_value);
		if ( $post_var_field_value != $check_post_var )
		{
			$ct_attack_detection = true;
			break;
		}
	}
}


if ( $ct_attack_detection )
{
	// include class for Logfile Management
	include_once($phpbb_root_path . 'ctracker/classes/class_log_manager.' . $phpEx);

	// write data into logfile
	$logfile = new log_manager();
	$logfile->write_worm();
	unset($logfile);

	// generate HTML Message
	$htmloutput =<<<EOM
  <html>
				     <head>
    				   <title>CBACK CrackerTracker :: Security Alert</title>
  					 </head>
  					 <body>
    				   <br>
    				   <div align="center">
      				   <table style="border:2px solid #000000" border="0" width="600" cellpadding="10" cellspacing="0">
         			     <tr>
          				   <td align="left" bgcolor="#000000"><font face="Tahoma, Arial, Helvetica" size="4" color="#FFFFFF"><b>SECURITY ALERT &raquo; &raquo; &raquo; &raquo;</b></font></td>
        				 </tr>
        				 <tr>
          				   <td bgcolor="#FFDFDF" align="left">
          						<font face="Tahoma, Arial, Helvetica" size="2" color="#000000">
          						  <b>CBACK CrackerTracker</b> has detected a potential attack on this site with a worm
          						  or exploit script so the Security System stopped the script.
          						  <br><br><br>
          						  If you can see this page after including a new MOD into your board or after clicking
          						  on a link please contact the Board Administrator with this error message and a description
          						  what you have done before you could see this page, that the Admin has the possibility to
          						  fix the problem.
          						</font>
          				    </td>
        				   </tr>
      				     </table>
    				   </div>
  					 </body>
				   </html>
EOM;

	// stop the script
	die($htmloutput);
}

// Tell the self test that this script was included correctly
define('protection_unit_one', true);

?>